org.apache.lucene.store

## Class ByteBuffersIndexInput

- java.lang.Object
- - org.apache.lucene.store.DataInput
  - - org.apache.lucene.store.IndexInput
    - - org.apache.lucene.store.ByteBuffersIndexInput

- All Implemented Interfaces:
    Closeable, AutoCloseable, Cloneable, RandomAccessInput

      public final class ByteBuffersIndexInput
      extends IndexInput
      implements RandomAccessInput

  An `IndexInput` implementing `RandomAccessInput` and backed by a `ByteBuffersDataInput`.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ByteBuffersIndexInput(ByteBuffersDataInput in, String resourceDescription)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IndexInput` | `clone()` Returns a clone of this stream.
    `void` | `close()` Closes the stream to further operations.
    `long` | `getFilePointer()` Returns the current position in this file, where the next read will occur.
    `long` | `length()` The number of bytes in the file.
    `RandomAccessInput` | `randomAccessSlice(long offset, long length)` Creates a random-access slice of this index input, with the given offset and length.
    `byte` | `readByte()` Reads and returns a single byte.
    `byte` | `readByte(long pos)` Reads a byte at the given position in the file
    `void` | `readBytes(byte[] b, int offset, int len)` Reads a specified number of bytes into an array at the specified offset.
    `void` | `readBytes(byte[] b, int offset, int len, boolean useBuffer)` Reads a specified number of bytes into an array at the specified offset with control over whether the read should be buffered (callers who have their own buffer should pass in "false" for useBuffer).
    `int` | `readInt()` Reads four bytes and returns an int.
    `int` | `readInt(long pos)` Reads an integer at the given position in the file
    `long` | `readLong()` Reads eight bytes and returns a long.
    `long` | `readLong(long pos)` Reads a long at the given position in the file
    `Map<String,String>` | `readMapOfStrings()` Reads a Map<String,String> previously written with `DataOutput.writeMapOfStrings(Map)`.
    `Set<String>` | `readSetOfStrings()` Reads a Set<String> previously written with `DataOutput.writeSetOfStrings(Set)`.
    `short` | `readShort()` Reads two bytes and returns a short.
    `short` | `readShort(long pos)` Reads a short at the given position in the file
    `String` | `readString()` Reads a string.
    `int` | `readVInt()` Reads an int stored in variable-length format.
    `long` | `readVLong()` Reads a long stored in variable-length format.
    `int` | `readZInt()` Read a `zig-zag`-encoded `variable-length` integer.
    `long` | `readZLong()` Read a `zig-zag`-encoded `variable-length` integer.
    `void` | `seek(long pos)` Sets current position in this file, where the next read will occur.
    `void` | `skipBytes(long numBytes)` Skip over `numBytes` bytes.
    `ByteBuffersIndexInput` | `slice(String sliceDescription, long offset, long length)` Creates a slice of this index input, with the given description, offset, and length.

    - ### Methods inherited from class org.apache.lucene.store.IndexInput

      `getFullSliceDescription, toString`

    - ### Methods inherited from class org.apache.lucene.store.DataInput

      `readLELongs`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ByteBuffersIndexInput

          public ByteBuffersIndexInput(ByteBuffersDataInput in,
                                       String resourceDescription)

  - ### Method Detail

    - #### close

          public void close()
                     throws IOException

      Description copied from class: `IndexInput`
      Closes the stream to further operations.
      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in class `IndexInput`
      Throws:
        `IOException`

    - #### getFilePointer

          public long getFilePointer()

      Description copied from class: `IndexInput`
      Returns the current position in this file, where the next read will occur.
      Specified by:
        `getFilePointer` in class `IndexInput`
      See Also:
        `IndexInput.seek(long)`

    - #### seek

          public void seek(long pos)
                    throws IOException

      Description copied from class: `IndexInput`
      Sets current position in this file, where the next read will occur. If this is beyond the end of the file then this will throw `EOFException` and then the stream is in an undetermined state.
      Specified by:
        `seek` in class `IndexInput`
      Throws:
        `IOException`
      See Also:
        `IndexInput.getFilePointer()`

    - #### length

          public long length()

      Description copied from class: `IndexInput`
      The number of bytes in the file.
      Specified by:
        `length` in class `IndexInput`

    - #### slice

          public ByteBuffersIndexInput slice(String sliceDescription,
                                             long offset,
                                             long length)
                                      throws IOException

      Description copied from class: `IndexInput`
      Creates a slice of this index input, with the given description, offset, and length. The slice is sought to the beginning.
      Specified by:
        `slice` in class `IndexInput`
      Throws:
        `IOException`

    - #### readByte

          public byte readByte()
                        throws IOException

      Description copied from class: `DataInput`
      Reads and returns a single byte.
      Specified by:
        `readByte` in class `DataInput`
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeByte(byte)`

    - #### readBytes

          public void readBytes(byte[] b,
                                int offset,
                                int len)
                         throws IOException

      Description copied from class: `DataInput`
      Reads a specified number of bytes into an array at the specified offset.
      Specified by:
        `readBytes` in class `DataInput`
      Parameters:
        `b` - the array to read bytes into
        `offset` - the offset in the array to start storing bytes
        `len` - the number of bytes to read
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeBytes(byte[],int)`

    - #### randomAccessSlice

          public RandomAccessInput randomAccessSlice(long offset,
                                                     long length)
                                              throws IOException

      Description copied from class: `IndexInput`
      Creates a random-access slice of this index input, with the given offset and length.

      The default implementation calls `IndexInput.slice(java.lang.String, long, long)`, and it doesn't support random access, it implements absolute reads as seek+read.

      Overrides:
        `randomAccessSlice` in class `IndexInput`
      Throws:
        `IOException`

    - #### readBytes

          public void readBytes(byte[] b,
                                int offset,
                                int len,
                                boolean useBuffer)
                         throws IOException

      Description copied from class: `DataInput`
      Reads a specified number of bytes into an array at the specified offset with control over whether the read should be buffered (callers who have their own buffer should pass in "false" for useBuffer). Currently only `BufferedIndexInput` respects this parameter.
      Overrides:
        `readBytes` in class `DataInput`
      Parameters:
        `b` - the array to read bytes into
        `offset` - the offset in the array to start storing bytes
        `len` - the number of bytes to read
        `useBuffer` - set to false if the caller will handle buffering.
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeBytes(byte[],int)`

    - #### readShort

          public short readShort()
                          throws IOException

      Description copied from class: `DataInput`
      Reads two bytes and returns a short.
      Overrides:
        `readShort` in class `DataInput`
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeByte(byte)`

    - #### readInt

          public int readInt()
                      throws IOException

      Description copied from class: `DataInput`
      Reads four bytes and returns an int.
      Overrides:
        `readInt` in class `DataInput`
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeInt(int)`

    - #### readVInt

          public int readVInt()
                       throws IOException

      Description copied from class: `DataInput`
      Reads an int stored in variable-length format. Reads between one and five bytes. Smaller values take fewer bytes. Negative numbers are supported, but should be avoided.

      The format is described further in `DataOutput.writeVInt(int)`.

      Overrides:
        `readVInt` in class `DataInput`
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeVInt(int)`

    - #### readZInt

          public int readZInt()
                       throws IOException

      Description copied from class: `DataInput`
      Read a `zig-zag`-encoded `variable-length` integer.
      Overrides:
        `readZInt` in class `DataInput`
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeZInt(int)`

    - #### readLong

          public long readLong()
                        throws IOException

      Description copied from class: `DataInput`
      Reads eight bytes and returns a long.
      Overrides:
        `readLong` in class `DataInput`
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeLong(long)`

    - #### readVLong

          public long readVLong()
                         throws IOException

      Description copied from class: `DataInput`
      Reads a long stored in variable-length format. Reads between one and nine bytes. Smaller values take fewer bytes. Negative numbers are not supported.

      The format is described further in `DataOutput.writeVInt(int)`.

      Overrides:
        `readVLong` in class `DataInput`
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeVLong(long)`

    - #### readZLong

          public long readZLong()
                         throws IOException

      Description copied from class: `DataInput`
      Read a `zig-zag`-encoded `variable-length` integer. Reads between one and ten bytes.
      Overrides:
        `readZLong` in class `DataInput`
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeZLong(long)`

    - #### readString

          public String readString()
                            throws IOException

      Description copied from class: `DataInput`
      Reads a string.
      Overrides:
        `readString` in class `DataInput`
      Throws:
        `IOException`
      See Also:
        `DataOutput.writeString(String)`

    - #### readMapOfStrings

          public Map<String,String> readMapOfStrings()
                                              throws IOException

      Description copied from class: `DataInput`
      Reads a Map<String,String> previously written with `DataOutput.writeMapOfStrings(Map)`.
      Overrides:
        `readMapOfStrings` in class `DataInput`
      Returns:
        An immutable map containing the written contents.
      Throws:
        `IOException`

    - #### readSetOfStrings

          public Set<String> readSetOfStrings()
                                       throws IOException

      Description copied from class: `DataInput`
      Reads a Set<String> previously written with `DataOutput.writeSetOfStrings(Set)`.
      Overrides:
        `readSetOfStrings` in class `DataInput`
      Returns:
        An immutable set containing the written contents.
      Throws:
        `IOException`

    - #### skipBytes

          public void skipBytes(long numBytes)
                         throws IOException

      Description copied from class: `DataInput`
      Skip over `numBytes` bytes. The contract on this method is that it should have the same behavior as reading the same number of bytes into a buffer and discarding its content. Negative values of `numBytes` are not supported.
      Overrides:
        `skipBytes` in class `DataInput`
      Throws:
        `IOException`

    - #### readByte

          public byte readByte(long pos)
                        throws IOException

      Description copied from interface: `RandomAccessInput`
      Reads a byte at the given position in the file
      Specified by:
        `readByte` in interface `RandomAccessInput`
      Throws:
        `IOException`
      See Also:
        `DataInput.readByte()`

    - #### readShort

          public short readShort(long pos)
                          throws IOException

      Description copied from interface: `RandomAccessInput`
      Reads a short at the given position in the file
      Specified by:
        `readShort` in interface `RandomAccessInput`
      Throws:
        `IOException`
      See Also:
        `DataInput.readShort()`

    - #### readInt

          public int readInt(long pos)
                      throws IOException

      Description copied from interface: `RandomAccessInput`
      Reads an integer at the given position in the file
      Specified by:
        `readInt` in interface `RandomAccessInput`
      Throws:
        `IOException`
      See Also:
        `DataInput.readInt()`

    - #### readLong

          public long readLong(long pos)
                        throws IOException

      Description copied from interface: `RandomAccessInput`
      Reads a long at the given position in the file
      Specified by:
        `readLong` in interface `RandomAccessInput`
      Throws:
        `IOException`
      See Also:
        `DataInput.readLong()`

    - #### clone

          public IndexInput clone()

      Description copied from class: `IndexInput`
      Returns a clone of this stream.

      Clones of a stream access the same data, and are positioned at the same point as the stream they were cloned from.

      Expert: Subclasses must ensure that clones may be positioned at different points in the input from each other and from the stream they were cloned from.

      Warning: Lucene never closes cloned `IndexInput`s, it will only call `IndexInput.close()` on the original object.

      If you access the cloned IndexInput after closing the original object, any `readXXX` methods will throw `AlreadyClosedException`.

      This method is NOT thread safe, so if the current `IndexInput` is being used by one thread while `clone` is called by another, disaster could strike.

      Overrides:
        `clone` in class `IndexInput`

Copyright © 2000-2021 Apache Software Foundation. All Rights Reserved.